Program Colonizarea_Planetei;
Uses Crt;
CONST MAXIM = 200;
Type Grup   = Array[1..MAXIM] Of Set Of Byte;
     Vector = Array[1..MAXIM] Of Byte;
Var G                    : Grup;
    f, Out               : Text;
    Clone, CardM, Contor : Vector;
    E, Index, Poz        : Vector;
    n, m, k, i, j, Aux   : Byte;
    Echipaj, X           : Set Of Byte;
    Mort, Pozitie        : Byte;
    Colonist, NumarClone : Byte;
    V                    : Array[1..MAXIM] Of String;
    Max, PozMax          : Byte;
    Test                 : String;

Procedure Quicksort(Lo, Hi, Ce: Byte);

     Procedure Sort(l, r: Byte);
     Var
       i, j, m : Byte;
       y, z : Byte;
       s, t : String;

     Begin
       i := l; j := r; m := (l + r) DIV 2;
       If Ce = 1 Then
           y := Clone[m]
       Else
           s := V[m];
       Repeat
           If Ce = 1 Then
               While Clone[i] > y Do Inc(i)
           Else
               While V[i] < s Do Inc(i);
           If Ce = 1 Then
               While y > Clone[j] Do Dec(j)
           Else
               While s < V[j] Do Dec(j);
           If i <= j Then
               Begin
                   If Ce = 1 Then
                       Begin
                           z := Clone[i];
                           Clone[i] := Clone[j];
                           Clone[j] := z;
                           z := E[i];
                           E[i] := E[j];
                           E[j] := z;
                       End
                   Else
                       Begin
                           t := V[i];
                           V[i] := V[j];
                           V[j] := t;
                           y := Index[i];
                           Index[i] := Index[j];
                           Index[j] := y
                       End;
                   Inc(i); Dec(j)
               End
       Until i > j;
       If l < j Then Sort(l, j);
       If i < r Then Sort(i, r);
     End;

Begin {quicksort};
  Sort(Lo, Hi);
End;

Function Vi_In_Vj(p, q : Byte) : Boolean;
Var r : Byte;
Begin
    Vi_In_Vj := True;
    For r := 1 To n - k Do
        If V[p][r] > V[q][r] Then
            Begin
                Vi_In_Vj := False;
                Exit
            End
End;

Function Suma(x : Vector; Cat : Byte) : Word;
Var i : Byte;
    s : Word;
Begin
    s := x[1];
    For i := 2 To Cat Do s:= s + x[i];
    Suma := s
End;

Procedure NU_EXISTA_SOLUTIE;
Begin
    ReWrite(Out);
    WriteLn(Out, 'NU EXISTA SOLUTIE');
    Close(Out);
{    ReadKey; }
    Halt(1)
End;

Procedure Afiseaza_Grupuri;
Begin
    For i := 1 To m Do
        Begin
           { Write('{'); }
            For j := 1 To n Do
                If j In G[i] Then Write(Out, j, ' ');
            WriteLn(Out, ' ')
        End
End;

Begin
    ClrScr;
    Write('Test : '); ReadLn(Test);
    Assign(f, Test); Reset(f);
    Assign(Out, 'Clone.out'); ReWrite(Out);
    ReadLn(f, n);
    ReadLn(f, m);
    ReadLn(f, k);
    Echipaj := [];
    For i := 1 To n Do Echipaj := Echipaj + [i]; {echipaj initial}
    For i := 1 To n Do Clone[i] := 1;            {daca nu se cloneaza = 1}
    For i := 1 To m Do Read(f, CardM[i]);        {capacitate supravietuire}
    For i := 1 To k Do
        Begin
            Read(f, Mort);                       {au murit la aterizare}
            Echipaj := Echipaj - [Mort];
            Clone[Mort] := 0;
        End;
    While Not(SeekEof(f)) Do                     {numar de clone }
        Begin
            ReadLn(f, Colonist, NumarClone);
            If (NumarClone >= m) Or Not (Colonist In Echipaj) Then
                NU_EXISTA_SOLUTIE;
            Clone[Colonist] := NumarClone + 1;
        End;
    Close(f);
    i := 1;                           {colonisti ramasi - elimin zerourile}
    While i < n - k + 1 Do
            If Clone[i] = 0 Then
                Begin
                    For j := i To n-1 Do Clone[j] := Clone[j + 1];
                    Clone[n] := 0
                End
            Else
                Inc(i);
    If Suma(Clone, n - k) > Suma(CardM, m) Then {daca sunt mai multi        }
        NU_EXISTA_SOLUTIE;                      {colonisti decat capacitatea}
                                                {de supravietuire totala a  }
                                                {planetei                   }
{ pastrez Echipaj in X }
    X := Echipaj;
{ mut Echipaj in E ca sa-l pot sorta descrescator pentru     }
{ formarea grupurilor                                        }
    i := 1; j := 0;
    While Echipaj <> [] Do
        Begin
            If i In Echipaj Then
                Begin
                    Inc(j);
                    E[j] := i;
                    Echipaj := Echipaj - [i]
                End;
            Inc(i)
        End;
{ ordonez descrescator dupa numar de clone}
    QuickSort(1, n - k, 1);
{ formez grupurile ... pot fi diferite, depinde de algoritmul de sortare}
    For i := 1 To m Do
        Begin
          For j := 1 To n-k Do
            If (Clone[j] > 0) And (Contor[i] < CardM[i]) Then
                Begin
                    G[i] := G[i] + [E[j]];
                    Dec(Clone[j]);
                    Inc(Contor[i])
                End;
{            QuickSort(1, n - k, 1);}
          For j := n-k DownTo 2 Do
             If Clone[j] > Clone[j-1] Then
                 Begin
                     Aux := Clone[j];
                     Clone[j] := Clone[j-1];
                     Clone[j-1] := Aux;
                     Aux := E[j];
                     E[j] := E[j-1];
                     E[j-1] := Aux
                 End;
        End;
    For i := 1 To m Do                       {daca un grup nu are nici}
        If G[i] = [] Then                    {o persoana => nu se pot }
            NU_EXISTA_SOLUTIE;               {regasi ca si clone in   }
                                             {alt grup - nu are cine}
    Echipaj := X;     { refac echipaj }
    Afiseaza_Grupuri;
{ formez vectori caracteristici pentru fiecare grup / fata de multimea totala}
    For i := 1 To m Do
        Begin
            V[i] := ''; Index[i] := i;     {Index[i] - indexul grupului i; pt afisare}
            For j := 1 To n Do
                If j In Echipaj Then
                    If j In G[i] Then V[i] := V[i] + '1'
                    Else V[i] := V[i] + '0'
        End;
{ ordonez lexicografic vectorii caracteristici  }
    QuickSort(1, m, 2);
{ acum daca grupul G[i] este inclus in grupul G[j] =>
  vectorul V[i] este "inaintea" lui V[j] in sirul ordonat}
{ deci pentru rezolvarea problemei....................}
{ determin un subsir crescator de lungime maxima -> programare dinamica}
    For i := 1 To m Do E[i] := 0;
    For i := m - 1 DownTo 1 Do
        Begin
            Max := 0;
            For j := i + 1 To m Do
                If (Vi_In_Vj(i, j)) And (Max < E[j] + 1) Then
                    Begin
                        Max := 1 + E[j];
                        PozMax := j
                    End;
            E[i] := Max; Poz[i] := PozMax
        End;
    Max := E[1]; PozMax := 1;
    For i := 2 To m Do
        If E[i] > Max Then
            Begin
                Max := E[i];
                PozMax := i;
            End;
{    If Max = 0 Then       }       {nu sunt minim 2 grupuri}
{        NU_EXISTA_SOLUTIE; }
    WriteLn(Out, Max + 1);            {numarul de grupuri}
    i := PozMax;
    While i <> 0 Do
        Begin
          {  Write(V[i], ' =====>  Grupul ', Index[i], ' {');} { se afiseaza Grupul G[i]}
            For j := 1 To n Do If j In G[Index[i]] Then Write(Out, j, ' '); WriteLn(Out, ' ');
            i := Poz[i];
        End;
    Close(Out)
{    ReadKey   }
End.
