{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R+,S+,T-,V+,X+,Y+}
{$m 60000,0,655360}
program Excel;
const NrMaxLin = 10;
      LgMax = 100;
type Linie     = 0 .. NrMaxLin;
     Coloana   = 'A' .. 'Z';
     Expresie  = string[LgMax];
     Celula    = record
                 data: Expresie;
                 v:    longint;
                 x:    byte;
                 end;
     Foaie     = array [Linie, Coloana] of Celula;

var  F: Foaie;
     n, l: Linie;
     m, i: byte; cm, c: char;
     fout: text; numeout: string;

procedure Citire;
var fin: text; nume: string;
    l: Linie; c: char;
begin
write ('fisier intrare '); readln (nume);
assign (fin, nume); reset (fin);
readln (fin, n, m); cm := chr (ord ('A') + m - 1);
for l := 0 to n-1 do
    for c := 'A' to cm do readln (fin, F[l, c].data);
close (fin);
end;

procedure Afisare;
var l: Linie; c: char;
begin
for l := 0 to n-1 do
    begin
    for c := 'A' to cm do write (fout, F[l, c].v:11);
    writeln (fout);
    end;
close (fout);
end;

function EvaluareExpresie (var e: Expresie; var i: byte): longint; forward;

function EvaluareFactor (var e: Expresie; var i: byte): longint;
var ll: Linie; cc: char; ii: byte; cod: integer; v: longint;
begin
if e[i] = '(' then  {verific daca factorul este o expresie intre paranteze}
   begin
   i := i + 1;  {trec peste')'}
   EvaluareFactor := EvaluareExpresie (e, i);  {evaluez expresia dintre paranteze}
   i := i + 1; {trec peste ')'}
   end
   else   {factorul este un operand}
   if e[i] in ['A' .. 'Z'] then {factorul este o referinta de celula}
      begin
      ll := ord (e[i+1]) - ord ('0'); cc := e[i];
      if F[ll, cc].x = 2 then EvaluareFactor := F[ll, cc].v
         else
         if F[ll, cc].x = 1 then
            begin
            writeln (fout, 'EVALUARE IMPOSIBILA');
            close (fout);
            halt;
            end
            else
            begin
            ii := 1;
            EvaluareFactor := EvaluareExpresie(F[ll, cc].data, ii);
            end;
      inc (i, 2);
      end
      else {factorul este o valoare  intreaga}
      begin
      ii := i + 1;
      while (ii <= length (e)) and (e[ii] in ['0' ..'9']) do inc (ii);
      val (copy (e, i, ii - i), v, cod);
      EvaluareFactor := v;
      i := ii;
      end
end;

function EvaluareTermen (var e: Expresie; var i: byte): longint;
var f: longint; op: char;
begin
f := EvaluareFactor (e, i);  {evaluez primul factor din care este constituit termenul};
while (i <= length (e)) and (e[i] in ['*', '/']) do  {mai urmeaza factori}
   begin
   op := e[i];
   i := i + 1; {trec peste '*'}
   if op = '*' then f := f * EvaluareFactor (e, i)
      else f := f div EvaluareFactor (e, i);
   end;
EvaluareTermen := f
end;

function EvaluareExpresie (var e: Expresie; var i: byte): longint;
var   t: longint;  op: char;
begin
t := EvaluareTermen (e, i);  {evaluez primul termen din expresie}
while (i < length (e)) and (e[i] in ['+', '-']) do  {mai urmeaza termeni}
      begin
      op := e[i];
      i := i + 1; {trec peste operator}
      if op = '+' then
         t := t + EvaluareTermen (e, i)
         else
         t := t - EvaluareTermen (e, i)
      end;
EvaluareExpresie := t
end;

begin {program principal}
Citire;
write ('Fisier iesire '); readln (numeout);
assign (fout, numeout); rewrite (fout);
for l := 0 to n-1 do
    for c := 'A' to cm do
        if F[l, c].x = 0 then
           begin
           F[l, c].x := 1;
           i := 1;
           F[l, c].v := EvaluareExpresie (F[l, c].data, i);
           F[l, c].x := 2;
           end;
Afisare;
end.