program Separabilitate;
const NMax = 101;
      Infinit = 2.0E10;
type  Vf = 0 .. NMax;
      Punct = record
              x, y: real;
              end;
      Poligon = array [Vf] of Punct;
var   P1, P2: Poligon;
      n1, n2: Vf;
      a, b, T: real;
      fout: text; numeout: string;

procedure Citire;
var fin: text; nume: string; i: Vf;
begin
write ('fisier intrare '); readln (nume);
{nume := 'harta.in';}
assign (fin, nume); reset (fin);
readln (fin, n1);
for i := 1 to n1 do readln (fin, P1[i].x, P1[i].y);
readln (fin, n2);
for i := 1 to n2 do readln (fin, P2[i].x, P2[i].y);
close (fin);
end;

function DreaptaJos (n: Vf; var P:Poligon): Vf;
{determina punctul cel mai din jos, cel mai din dreapta}
var i, imin: Vf;
begin
imin := 1;
for i := 2 to n do
    if (P[i].y < P[imin].y) or ((P[i].y = P[imin].y) and (P[i].x > P[imin].x)) then imin := i;
DreaptaJos := imin;
end;

function Arg (x, y: real): real;
begin
if x = 0 then Arg := 90
   else
   if y/x > 0 then Arg := 180 * arctan (y/x)/Pi
      else Arg := 180 - 180*arctan (-y/x)/Pi
end;

function IntoarcereDreapta (x1, y1, x2, y2, x3, y3: real): boolean;
begin
IntoarcereDreapta := (x1 * y2 + x2 * y3 + x3 * y1 - x3 * y2 - x1 * y3 - x2 * y1) < 0;
end;

procedure ConstructiePoligon (var n: Vf; var P: Poligon);
type Lista = ^NodLista;
     NodLista = record
                x, y, r, t: real;
                urm, pre: Lista;
                end;
var L, q, pp, sf, u: Lista;
    i, imin: Vf; x0, y0: real;
begin
{construiesc lista dublu inlantuita a punctelor, ordonata crescator dupa argument;
coordonatele polare sunt calculate relativ la punctul cel mai de jos, cel mai din dreapta}
imin := DreaptaJos (n, P);
x0 := P[imin].x; y0 := P[imin].y;
new (L); L^.x := P[imin].x; L^.y := P[imin].y; L^.r := 0; L^.t := 0; L^.pre := nil; L^.urm := nil;  sf := L;
{inserez succesiv punctele in lista}
for i := 1 to n do
    if i <> imin then
       begin
       new (pp); pp^.x := P[i].x; pp^.y := P[i].y;
       pp^.r := sqrt (sqr (pp^.x - x0) + sqr (pp^.y - y0)); pp^.t := Arg (pp^.x - x0, pp^.y - y0);
       {inserez pp in lista}
       q := L;
       while (q <> nil) and (q^.t < pp^.t) do q := q^.urm;
       if (q <> nil) and (q^.t = pp^.t) then
          begin if pp^.r > q^.r then begin q^.x := pp^.x; q^.y := pp^.y; q^.r := pp^.r; dispose (pp) end end
          else
          begin
          {inserez pp inaintea lui q} pp^.urm := q;
          if q = nil then begin pp^.pre := sf; sf^.urm := pp; sf := pp; end
             else begin pp^.pre := q^.pre; pp^.pre^.urm := pp; q^.pre := pp; end;
          end;
    end;
{elimin din lista varfurile care nu apartin infasuratorii convexe}
pp := L; q := pp^.urm;
if q <> nil then
   begin
   u := q^.urm;
   while u <> nil do
      begin
      {verific daca q apartine infasuratorii convexe}
         if IntoarcereDreapta (pp^.x, pp^.y, q^.x, q^.y, u^.x, u^.y) then
            begin {elimin q din lista}
            pp^.urm := u; u^.pre := pp; dispose (q);
            q := pp; pp := pp^.pre;
            end
            else begin pp := q; q := q^.urm; u := q^.urm; end;
      end;
   end;
{transfer in P, numai varfurile poligonului care reprezinta infasuratoarea convexa}
n := 0;
while L <> nil do
      begin
      inc (n); P[n].x := L^.x; P[n].y := L^.y;
      q := L; L := L^.urm; dispose (q);
      end;
end;


function Interior (n: Vf; var P: Poligon; x, y: real): boolean;
{intoarce true daca punctul de coordonate x, y se gaseste in interiorul poligonului P}
var f1, f2: real; i: Vf;
begin
Interior := true;
P[0] := P[n]; P[n+1] := P[1];
for i := 1 to n do
    begin
    f1 := (x - P[i].x)*(P[i-1].y - P[i].y) - (y - P[i].y)*(P[i-1].x - P[i].x);
    f2 := (P[i+1].x - P[i].x)*(P[i-1].y - P[i].y) - (P[i+1].y - P[i].y)*(P[i-1].x - P[i].x);
    if f1 * f2 <= 0 then begin Interior := false; exit; end
    end
end;

function SegmentIntersect (a, b, c, d: Punct): boolean;
var x1, x2, x3, x4, y1, y2, y3, y4: real;
begin
SegmentIntersect := false;
if a.x < b.x then begin x1 := a.x; x2 := b.x end
   else begin x2 := a.x; x1 := b.x end;
if a.y < b.y then begin y1 := a.y; y2 := b.y end
   else begin y1 := a.y; y2 := b.y end;
if c.x < d.x then begin x3 := c.x; x4 := d.x end
   else begin x3 := d.x; x4 := c.x end;
if c.y < d.y then begin y3 := c.y; y4 := d.y end
   else begin y4 := c.y; y3 := d.y end;
if (x1 <= x4) and (x2 >= x3) and (y2 >= y3) and (y4 >= y1) then
   if ((c.x-a.x)*(b.y-a.y)-(b.x-a.x)*(c.y-a.y)) * ((d.x-a.x)*(b.y-a.y)-(b.x-a.x)*(d.y-a.y))<= 0 then SegmentIntersect := true;
end;

function Intersect(n1: Vf; var P1: Poligon; n2: Vf; var P2: Poligon): boolean;
var i, j: Vf;
begin
Intersect := false;
P1[0] := P1[n1]; P2[0] := P2[n2];
if (n1 > 1) and (n2 > 1) then
   for i := 1 to n1 do
       for j := 1 to n2 do
           if SegmentIntersect(P1[i-1], P1[i], P2[j-1], P2[j]) then begin Intersect := true; exit; end;
{testez daca P1 inclus in P2 sau invers}
if (n2 > 2) and Interior (n2, P2, P1[1].x, P1[1].y)  then begin Intersect := true; exit end;
if (n1 > 2) and Interior (n1, P1, P2[1].x, P2[1].y) then Intersect := true;
end;

function DistPunctSegment (A, B, C: Punct; var PM: Punct): real;
{intoarce distanta de la punctul A la dreapta BC; PM este mijlocul distantei}
var  alfa, m, m1, x0, y0: real;
begin
if C.x <> B.x then
   begin
   m := (C.y - B.y)/(C.x - B.x);
   if m <> 0 then begin m1 := -1/m; x0 := (m1* A.x - m * B.x + B.y - A.y)/(m1 - m); y0 := m * (x0 - B.x) + B.y; end
      else begin x0 := A.x; y0 := B.y end;
   alfa := (x0 - C.x)/(B.x - C.x);
   end
   else begin x0 := B.x; y0 := A.y; alfa := (y0 - C.y)/(B.y - C.y) end;
if (0 <= alfa) and (alfa <= 1) then DistPunctSegment := sqrt (sqr (A.x - x0) + sqr (A.y - y0))
    else DistPunctSegment := Infinit;
PM.x := (x0 + A.x)/2; PM.y := (A.y + y0)/2;
end;

function DistMinVfLatura (n1: Vf; var P1: Poligon; n2: Vf; var P2: Poligon; var imin, jmin: Vf; var PM: Punct): real;
{functia determina cel mai apropiat varf din P1 de o latura a lui P2; intoarce distanta minima}
var  min, d: real;  aux: Punct; i, j: Vf;
begin
min := DistPunctSegment (P1[1], P2[0], P2[1], PM); imin := 1; jmin := 1;
for i := 1 to n1 do
    for j := 1 to n2 do
        begin
        d := DistPunctSegment (P1[i], P2[j-1], P2[j], aux);
        if d < min then begin PM := aux; min := d; imin := i; jmin := j; end;
        end;
DistMinVfLatura := min;
end;

procedure Determina;
const infinit = 2.E10;
{determina coeficientii unei drepte care sa separe cele doua poligoane}
var min1, min2: real;  imin1, jmin1, imin2, jmin2: Vf; PM1, PM2: Punct;
begin
if n2 > 1 then min1 := DistMinVfLatura (n1, P1, n2, P2, imin1, jmin1, PM1) else min1 := infinit;
if n1 > 1 then min2 := DistMinVfLatura (n2, P2, n1, P1, imin2, jmin2, PM2) else min2 := infinit;
b := -1;
if min1 < min2 then
   if P2[jmin1].x - P2[jmin1 - 1].x <> 0 then
      begin
      a := (P2[jmin1].y - P2[jmin1 - 1].y)/(P2[jmin1].x - P2[jmin1 - 1].x);
      T := a * PM1.x - PM1.y
      end
      else
      begin a := 1;  b := 0; T := PM1.x; end
   else
   if P1[jmin2].x - P1[jmin2 - 1].x <> 0 then
      begin
      a := (P1[jmin2].y - P1[jmin2 - 1].y)/(P1[jmin2].x - P1[jmin2 - 1].x);
      T := a * PM2.x - PM2.y
      end
      else begin a := 1; b := 0; T := PM2.x end;
end;

procedure Extreme (n: Vf; var P: Poligon; var xmin, ymin, xmax, ymax: real);
var i: Vf;
begin
xmin := P[1].x; xmax := P[1].x; ymin := P[1].y; ymax := P[1].y;
for i := 2 to n do
    begin
    if P[i].x < xmin then xmin := P[i].x
       else if P[i].x > xmax then xmax := P[i].x;
    if P[i].y < ymin then ymin := P[i].y
       else if P[i].y > ymax then ymax := P[i].y;
    end
end;

function SeparareParalelaAxe: boolean;
var xmin1, xmin2, xmax1, xmax2, ymin1, ymin2, ymax1, ymax2: real;
begin
Extreme (n1, P1, xmin1, ymin1, xmax1, ymax1);
Extreme (n2, P2, xmin2, ymin2, xmax2, ymax2);
SeparareParalelaAxe := true;
if (xmax1 < xmin2)  then begin a := 1; b := 0; T := (xmax1 + xmin2)/2 end
   else
   if (xmax2 < xmin1) then begin a := 1; b := 0; T := (xmax2 + xmin1)/2 end
      else
      if (ymax2 < ymin1) then begin a := 0; b := 1; T := (ymax2 + ymin1)/2 end
         else
         if (ymax1 < ymin2) then begin a := 0; b := 1; T := (ymax1 + ymin2)/2 end
            else SeparareParalelaAxe := false;
end;

begin {program principal}
Citire;
if n1 > 2 then ConstructiePoligon (n1, P1);
if n2 > 2 then ConstructiePoligon (n2, P2);
write ('fisier iesire '); readln (numeout);
assign (fout, numeout);
{assign (fout, 'harta.out'); }rewrite (fout);
if Intersect(n1, P1, n2, P2) then writeln (fout, 'COLONIILE NU POT FI SEPARATE PRINTR-O FRONTIERA RECTILINIE')
   else
   begin
   writeln (fout, 'COLONIILE POT FI SEPARATE PRINTR-O FRONTIERA RECTILINIE');
   if NOT SeparareParalelaAxe Then Determina;
   writeln (fout, a:10:2, b:10:2, T:10:2);
   end;
close (fout);
end.

