Program Validare_Grupuri_Colonizatoare;
Uses Crt;
CONST MAXIM = 200;
      NU    = 'NU EXISTA SOLUTIE';
Type Grup   = Array[1..MAXIM] Of Set Of Byte;
     Vector = Array[1..MAXIM] Of Byte;
Var G                       : Grup;
    f, Out, Rez             : Text;
    Clone, CardM, Contor    : Vector;
    E, Index, Poz           : Vector;
    n, m, k, i, j, z        : Byte;
    Echipaj, X              : Set Of Byte;
    Mort, Pozitie, MaxOut   : Byte;
    Colonist, NumarClone    : Byte;
    V                       : Array[1..MAXIM] Of String;
    Max, PozMax             : Byte;
    Test, FRez, DaNu, Mesaj : String;

Procedure Quicksort(Lo, Hi, Ce: Byte);

     Procedure Sort(l, r: Byte);
     Var
       i, j, m : Byte;
       y, z : Byte;
       s, t : String;

     Begin
       i := l; j := r; m := (l + r) DIV 2;
       s := V[m];
       Repeat
           While V[i] < s Do Inc(i);
           While s < V[j] Do Dec(j);
           If i <= j Then
                Begin
                    t := V[i];
                    V[i] := V[j];
                    V[j] := t;
                    y := Index[i];
                    Index[i] := Index[j];
                    Index[j] := y;
                    Inc(i); Dec(j)
                End;
       Until i > j;
       If l < j Then Sort(l, j);
       If i < r Then Sort(i, r);
     End;

Begin {quicksort};
  Sort(Lo, Hi);
End;

Function Vi_In_Vj(p, q : Byte) : Boolean;
Var r : Byte;
Begin
    Vi_In_Vj := True;
    For r := 1 To n - k Do
        If V[p][r] > V[q][r] Then
            Begin
                Vi_In_Vj := False;
                Exit
            End
End;

Function Suma(xx : Vector; Cat : Byte) : Word;
Var i : Byte;
    s : Word;
Begin
    s := xx[1];
    For i := 2 To Cat Do s:= s + xx[i];
    Suma := s
End;

Procedure INCORECT;
Begin
    WriteLn('Testul ', Test, ' INCORECT!!!');
    Close(Out);
    ReadKey;
    Halt(1)
End;

Procedure NU_EXISTA_SOLUTIE;
Begin
    ReadLn(Out, Mesaj);
    If Mesaj = NU Then
            WriteLn('Testul ', Test, ' CORECT')
    Else
            WriteLn('Testul ', Test, ' INCORECT!!!');
    Close(Out);
    ReadKey;
    Halt(1)
End;

Begin
    ClrScr;
    Write('Test : '); ReadLn(Test);
    Assign(f, Test); Reset(f);
    Assign(Out, 'Clone.out'); Reset(Out);
    FRez := 'R'+ Test;
    Assign(Rez, FRez); Reset(Rez);
    ReadLn(Rez, DaNu);
    If DaNu = 'NU' Then
        Begin
            ReadLn(Out, Mesaj);
            If Mesaj = NU Then
                    WriteLn('Testul ', Test, ' CORECT')
            Else
                    WriteLn('Testul ', Test, ' INCORECT!!!');
            Close(Out);
            ReadKey;
            Halt(1)
        End
    Else
Begin
    ReadLn(f, n);
    ReadLn(f, m);
    ReadLn(f, k);
    Echipaj := [];
    For i := 1 To n Do Echipaj := Echipaj + [i]; {echipaj initial}
    For i := 1 To n Do Clone[i] := 1;            {daca nu se cloneaza = 1}
    For i := 1 To m Do Read(f, CardM[i]);        {capacitate supravietuire}
    For i := 1 To k Do
        Begin
            Read(f, Mort);                       {au murit la aterizare}
            Echipaj := Echipaj - [Mort];
            Clone[Mort] := 0;
        End;
    While Not(SeekEof(f)) Do                     {numar de clone }
        Begin
            ReadLn(f, Colonist, NumarClone);
            If (NumarClone >= m) Or Not (Colonist In Echipaj) Then
                NU_EXISTA_SOLUTIE;
            Clone[Colonist] := NumarClone + 1;
        End;
    Close(f);
    i := 1;                           {colonisti ramasi - elimin zerourile}
    While i < n - k + 1 Do
            If Clone[i] = 0 Then
                Begin
                    For j := i To n-1 Do Clone[j] := Clone[j + 1];
                    Clone[n] := 0
                End
            Else
                Inc(i);
    If Suma(Clone, n - k) > Suma(CardM, m) Then {daca sunt mai multi        }
        NU_EXISTA_SOLUTIE;                      {colonisti decat capacitatea}
                                                {de supravietuire totala a  }
                                                {planetei                   }
{ pastrez Echipaj in X }
    X := Echipaj;
    Echipaj := [];
    For i := 1 To m Do
        Begin
            E[i] := 0;
            While Not(SeekEoln(Out)) Do
                Begin
                    Read(Out, z);
                    If z In G[i] Then
                        INCORECT;
                    Inc(E[i]);
                    G[i] := G[i] + [z];
                    Echipaj := Echipaj + [z]
                End;
            ReadLn(Out);
            If E[i] <> CardM[i] Then
                INCORECT;
        End;
    If Echipaj <> X Then
        INCORECT;
{ formez vectori caracteristici pentru fiecare grup / fata de multimea totala}
    For i := 1 To m Do
        Begin
            V[i] := ''; Index[i] := i;     {Index[i] - indexul grupului i; pt afisare}
            For j := 1 To n Do
                If j In Echipaj Then
                    If j In G[i] Then V[i] := V[i] + '1'
                    Else V[i] := V[i] + '0'
        End;
{ ordonez lexicografic vectorii caracteristici  }
    QuickSort(1, m, 2);
{ acum daca vectorul V[i] este "inaintea" lui V[j] =>
  grupul G[i] este inclus in grupul G[j]             }
{ deci pentru rezolvarea problemei....................}
{ determin un subsir crescator de lungime maxima -> programare dinamica}
    For i := 1 To m Do E[i] := 0;
    For i := m - 1 DownTo 1 Do
        Begin
            Max := 0;
            For j := i + 1 To m Do
                If (Vi_In_Vj(i, j)) And (Max < E[j] + 1) Then
                    Begin
                        Max := 1 + E[j];
                        PozMax := j
                    End;
            E[i] := Max; Poz[i] := PozMax
        End;
    Max := E[1]; PozMax := 1;
    For i := 2 To m Do
        If E[i] > Max Then
            Begin
                Max := E[i];
                PozMax := i;
            End;
    If Max = 0 Then              {nu sunt minim 2 grupuri}
        NU_EXISTA_SOLUTIE;
    ReadLn(Out, MaxOut);
    If MaxOut <> Max + 1 Then
        INCORECT;
    G[1] := [];
    While Not(SeekEoLn(Out)) Do
        Begin
            Read(Out, z);
            G[1] := G[1] + [z];
        End;
    ReadLn(Out);
    For i := 1 To Max Do
        Begin
            G[2] := [];
            While Not(SeekEoLn(Out)) Do
                Begin
                    Read(Out, z);
                    G[2] := G[2] + [z];
                End;
            ReadLn(Out);
            If Not(G[1] <= G[2]) Then
                INCORECT;
            G[1] := G[2]
        End;
    Close(Out);
    WriteLn('Testul ', Test, ' CORECT');
    ReadKey;
End
End.
