
{ Cls XII - Ziua 1 Problema 1 Bomboane }

const
  InStr : string = 'bonbon.in';
  OutStr : string = 'bonbon.out';

var
  N, M : Integer;
  A : array[1..100, 1..100] of Integer;
  X, sol : array[1..100] of Integer;
  Sum, MinSum : Longint;
  Occupied : array[1..100] of Boolean;
  Timer : Longint absolute $0040:$006C;
  Alarm : Longint;

procedure Solve(I, J : Integer);
var
  K : Integer;
begin
  if I <> 0 then
  begin
    X[I] := J;
    if I = N then
    begin
      if Sum < MinSum then
      begin
        MinSum := Sum;
        for K := 1 to N do Sol[K] := X[K];
      end;
      Exit;
    end;
  end;
  for K := 1 to N do
    if (A[I + 1, K] < MaxInt) and (Occupied[K] = False) and (Timer < Alarm) then
    begin
      Inc(Sum, A[I + 1, K]);
      if Sum <= MinSum then { must be smaller that previous min sum }
      begin
        Occupied[K] := True;
        Solve(I + 1, K);
        Occupied[K] := False;
      end;
      Dec(Sum, A[I + 1, K]);
    end;
end;

procedure ReadInputData;
var
  F : Text;
  I, J, X : Integer;
begin
  Assign(F, InStr);
  Reset(F);
  ReadLn(F, N, M);
  for I := 1 to N do
    for J := 1 to N do
      A[I, J] := MaxInt;
  for I := 1 to N do
  begin
    Occupied[I] := False;
    for J := 1 to M do
    begin
      Read(F, X);
      A[I, X] := Abs(I - X);
    end;
    ReadLn(F);
  end;
  Close(F);
end;

procedure WriteOutputData;
var
  F : Text;
  I : Integer;
begin
  Assign(F, OutStr);
  Rewrite(F);
  WriteLn(F, MinSum);
  for I := 1 to N do X[Sol[I]] := I;
  for I := 1 to N do Write(F, X[I], ' ');
  Close(F);
end;

begin
  Alarm := Timer + 6*17;

  ReadInputData;
  MinSum := MaxInt;

  Solve(0, 0);
  WriteOutputData;
end.