program Ciocniri;
uses crt;
const max=250;
type bila=record
                x,y,d:integer;
                end;
var fin,fout:text;
    b:array[1..max] of bila;
    destr,done:array[0..max] of boolean;
    m,n,k:byte;
    t:word;

function ReadData:boolean;
begin
if SeekEof(fin) then ReadData:=false
else
    begin
    ReadLn(fin,m,n);
    ReadLn(fin,t);
    k:=0;
    while not SeekEof(fin) do
          begin
          k:=k+1;
          ReadLn(fin,b[k].x,b[k].y,b[k].d);
          end;
    ReadData:=true;
    end;
end;

procedure MoveAll;
const dir:array[1..4,1..2] of integer=((1,1),(-1,1),(-1,-1),(1,-1));
var j:byte;
begin
for j:=1 to k do
    if not destr[j] then
       begin
       b[j].x:=b[j].x+dir[b[j].d,1];
       b[j].y:=b[j].y+dir[b[j].d,2];
       if b[j].x<0 then
          begin
          b[j].x:=1;
          if b[j].d=2 then
             b[j].d:=1
          else
              b[j].d:=4;
          end;
       if b[j].x>m then
          begin
          b[j].x:=m-1;
          if b[j].d=1 then
             b[j].d:=2
          else
              b[j].d:=3;
          end;
       if b[j].y<0 then
          begin
          b[j].y:=1;
          if b[j].d=3 then
             b[j].d:=2
          else
              b[j].d:=1;
          end;
       if b[j].y>n then
          begin
          b[j].y:=n-1;
          if b[j].d=1 then
             b[j].d:=4
          else
              b[j].d:=3;
          end;
       end;
end;

procedure Destroy;
var i,j:byte;
begin
for i:=1 to k-1 do
    for j:=i+1 to k do
        if (b[i].x=b[j].x) and (b[i].y=b[j].y) and (i<>j) then
           begin
           if b[i].d=1 then
              begin
              destr[i]:=true;
              if b[j].d=3 then
                 destr[j]:=true;
              end;
           if b[i].d=2 then
                 begin
                 if b[j].d<>1 then
                    destr[i]:=true;
                 if (b[j].d=1) or (b[j].d=4) then
                    destr[j]:=true;
                 end;
           if b[i].d=3 then
                 begin
                 if b[j].d=1 then
                    destr[i]:=true;
                 destr[j]:=true;
                 end;
           if b[i].d=4 then
                 begin
                 if b[j].d<>1 then
                    destr[i]:=true;
                 if (b[j].d=1) or (b[j].d=2) then
                    destr[j]:=true;
                 end;
           end;
end;

procedure Clear;
var i:byte;
begin
for i:=1 to k do
    if (destr[i]) and (not done[i]) then
       begin
       b[i].x:=0;
       b[i].y:=0;
       done[i]:=true;
       end;
end;

procedure Start;
var i:word;
begin
for i:=1 to t do
    begin
    MoveAll;
    Destroy;
    Clear;
    end;
end;

procedure WriteSol;
var i,count:byte;
begin
count:=0;
for i:=1 to k do
    if not done[i] then
       count:=count+1;
WriteLn(fout,count);
for i:=1 to k do
    if not done[i] then
       WriteLn(fout,b[i].x,' ',b[i].y);
end;

begin
Assign(fin,'input.txt');
Assign(fout,'output.txt');
Reset(fin);
Rewrite(fout);
while ReadData do
      begin
      FillChar(destr,max,false);
      FillChar(done,max,false);
      Start;
      WriteSol;
      end;
Close(fin);
Close(fout);
end.