{ CADAR CRISTIAN }
{$b-,r-,s-}
{$M 65000,0,655360}
type
    punct=
          record
                x,y:byte;
          end;
var
   a,a1:array[1..5000] of punct;
   max,aux,minx,maxx,n,i,j,l,l1,l2:integer;
   s1x,s1y,s2x,s2y,miny,maxy:integer;
   ix,sx,iy,sy:array[1..255] of integer;
   lin,col:array[0..256] of integer;
   f:text;
   timp:longint absolute $0:$046c;
   alarm:longint;

procedure citire;
begin
     assign(f,'input.txt');
     reset(f);
     readln(f,l1,l2);
     readln(f,n);
     minx:=300;
     maxx:=0;
     miny:=300;
     maxy:=0;
     fillchar(lin,sizeof(lin),0);
     fillchar(col,sizeof(col),0);
     for i:=1 to n do
         begin
              readln(f,a[i].x,a[i].y);
              if a[i].x<minx
                 then minx:=a[i].x;
              if a[i].x>maxx
                 then maxx:=a[i].x;
              if a[i].y<miny
                 then miny:=a[i].y;
              if a[i].y>maxy
                 then maxy:=a[i].y;
              inc(lin[a[i].y]);
              inc(col[a[i].x]);
         end;
     close(f);
end;

procedure optimizare;
begin
     lin[minx-1]:=0;
     for i:=minx to maxx do
         lin[i]:=lin[i]+lin[i-1];
     lin[miny-1]:=0;
     for i:=miny to maxy do
         col[i]:=col[i]+col[i-1];
end;

procedure Sort1(l,r:integer);
var
   i,j,x:integer;
   y:punct;
begin
  i:=l; j:=r; x:=a[(l+r) div 2].x;
  repeat
    while a[i].x < x do i:=i+1;
    while x < a[j].x do j:=j-1;
    if i<=j then
    begin
         y:=a[i]; a[i]:=a[j]; a[j]:=y;
         i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then Sort1(l, j);
  if i<r then Sort1(i, r);
end;

procedure Sort2(l,r:integer);
var
   i,j,x:integer;
   y:punct;
begin
  i:=l; j:=r; x:=a1[(l+r) div 2].y;
  repeat
    while a1[i].y < x do i:=i+1;
    while x < a1[j].y do j:=j-1;
    if i<=j then
    begin
         y:=a1[i]; a1[i]:=a1[j]; a1[j]:=y;
         i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then Sort2(l, j);
  if i<r then Sort2(i, r);
end;

procedure ordine;
begin
     for i:=minx to maxx do
         begin
              ix[i]:=maxint;
              sx[i]:=0;
         end;
     for i:=minx to maxx do
         for j:=1 to n do
             begin
                  if (a[j].x>=i) and (ix[i]>j)
                     then ix[i]:=j;
                  if (a[j].x<=i) and (sx[i]<j)
                     then sx[i]:=j;
             end;
     {--}
     for i:=miny to maxy do
         begin
              iy[i]:=maxint;
              sy[i]:=0;
         end;
     for i:=miny to maxy do
         for j:=1 to n do
             begin
                  if (a1[j].y>=i) and (iy[i]>j)
                     then iy[i]:=j;
                  if (a1[j].y<=i) and (sy[i]<j)
                     then sy[i]:=j;
             end;
end;

function minim(a,b:integer):integer;
begin
     if a<b
        then minim:=a
        else minim:=b;
end;

function calcul(x1,y1,x2,y2:byte):integer;
var
   i,nr:integer;
begin
     if (minim(lin[y2]-lin[y1],col[x2]-col[x1])<=max)
     or ( (ix[x1]>sx[x1]) and (ix[x2]>sx[x2]) and (iy[y1]>sy[y1]) and (iy[y2]>sy[y2]) )
        then exit;
     nr:=0;
     if sx[x2]-ix[x1]<sy[y2]-iy[y1]
        then  { caut pe x }
            begin
                 for i:=ix[x1] to sx[x2] do
                     if (a[i].y>=y1) and (a[i].y<=y2)
                        then inc(nr);
            end
        else { caut pe y }
            begin
                 for i:=iy[y1] to sy[y2] do
                     if (a1[i].x>=x1) and (a1[i].x<=x2)
                        then inc(nr);
            end;
     calcul:=nr;
end;

procedure afisare;
var
   x1,x2,y1,y2:integer;
begin
     assign(f,'output.txt');
     rewrite(f);
     writeln(f,max);
     writeln(f,s1x,' ',s1y);
     x1:=s1x;y1:=s1y;
     x2:=s2x;y2:=s2y;
     if sx[x2]-ix[x1]<sy[y2]-iy[y1]
        then  { caut pe x }
            begin
                 for i:=ix[x1] to sx[x2] do
                     if (a[i].y>=y1) and (a[i].y<=y2)
                        then writeln(f,a[i].x,' ',a[i].y);
            end
        else { caut pe y }
            begin
                 for i:=iy[y1] to sy[y2] do
                     if (a1[i].x>=x1) and (a1[i].x<=x2)
                        then writeln(f,a1[i].x,' ',a1[i].y);
            end;
     close(f);
     halt;
end;

procedure prelucrare;
begin
     max:=0;
     for i:=minx to maxx do
         for j:=miny to maxy do
             begin
                  if timp>alarm
                     then afisare;
                  if (i+l1<=maxx) and (j+l2<=maxy)
                     then aux:=calcul(i,j,i+l1,j+l2);
                  if max<aux
                     then
                         begin
                              max:=aux;
                              s1x:=i;s1y:=j;
                              s2x:=i+l1;s2y:=j+l2;
                         end;
                  if (i+l2<=maxx) and (j+l1<=maxy)
                     then calcul(i,j,i+l2,j+l1);
                  if max<aux
                     then
                         begin
                              max:=aux;
                              s1x:=i;s1y:=j;
                              s2x:=i+l2;s2y:=j+l1;
                         end;
             end;
end;

begin
     alarm:=timp+4*17;
     citire;
     optimizare;
     sort1(1,n);
     a1:=a;
     sort2(1,n);
     ordine;
     prelucrare;
     afisare;
end.