#include<fstream.h>
#include<assert.h>

unsigned char x[5000],y[5000];
int m,n,p,cx,cy,np,bp,bpx,bpy,ip;
typedef struct pct {
	struct pct *next;
	int p;
	} em;
struct pct *lx[255];

void main(void) {
	/* Reading data, assigning areas */
	ifstream fin("input.txt");
	for(int i=0;i<255;i++) lx[i]=NULL;
	fin>>m>>n>>p;
	for(i=0;i<p;i++) {
		int md1,md2; fin>>md1>>md2; x[i]=md1; y[i]=md2;
		/* Inserting the point in the list he is assumed to be */
		if(lx[x[i]]==NULL) {
			lx[x[i]]=new em;
		/* Under Borland C++ IDE, the following line exits the program with error
				if there is not enough memory to create the lists. */
			assert(lx[x[i]]!=NULL);
			lx[x[i]]->next=NULL;
			lx[x[i]]->p=i;
		} else {
			em *a=lx[x[i]];
			if(y[a->p]>y[i]) {
				em *b=new em;
				b->next=a;
				b->p=i;
				lx[x[i]]=b;
			} else {
				while(a->next!=NULL&&y[a->next->p]<y[i]) a=a->next;
				if(a->next==NULL) { a->next=new em; a->next->next=NULL; a->next->p=i; }
				else {
					em *b=a->next;
					a->next=new em; a->next->next=b; a->next->p=i;
					};
				};
		};
		/* The other list can be used as well, even if I don't use it later..
																									it could do for speedup */
		/* I'm having problems with memory, this part is gone :) */
/*
		if(ly[y[i]]==NULL) {
			ly[y[i]]=new em;
			assert(ly[y[i]]!=NULL);
			ly[y[i]]->next=NULL;
			ly[y[i]]->p=i;
		} else {
			em *a=ly[y[i]];
			while(x[a->p]<x[i]&&a->next!=NULL) a=a->next;
			if(a->next==NULL) { a->next=new em; a->next->next=NULL; a->next->p=i; }
			else {
				em *b=a->next;
				a->next=new em; a->next->next=b; a->next->p=i;
				};
		};
*/
		};
	fin.close();
	/* Done reading data */
	bp=0; bpx=0; bpy=0;
	for(int iy=1;iy<=255;iy++) {
		/* First rectangle with base on row iy */
		np=0; cx=1; cy=iy;
		for(i=1;i<=m+1;i++) {
			em *a=lx[i];
			do {
				if(a!=NULL&&y[a->p]<=iy+n&&y[a->p]>=iy) np++;
				if(a!=NULL) a=a->next;
			} while(a!=NULL&&y[a->p]<=iy+n&&y[a->p]>=iy);
			};
		if(np>bp) { bp=np; bpx=cx; bpy=cy; };
		/* Now, moving rectangle */
		for(i=1;i<=255-m-1;i++) {
			cx++;				/* To the right, until we get to the border */
			em *a=lx[cx-1];
			/* Decreasing the number of points by the column that's gone */
			do {
				if(a!=NULL&&y[a->p]<=iy+n&&y[a->p]>=iy) np--;
				if(a!=NULL) a=a->next;
			} while(a!=NULL&&y[a->p]<=iy+n&&y[a->p]>=iy);
			/* Done */
			/* Now increasing the number of points by the column that comes */
			a=lx[cx+m];
			do {
				if(a!=NULL&&y[a->p]<=iy+n&&y[a->p]>=iy) np++;
				if(a!=NULL) a=a->next;
			} while(a!=NULL&&y[a->p]<=iy+n&&y[a->p]>=iy);
			/* Done */
			/* Checking for best result.. who can tell? :) */
			if(np>bp) { bp=np; bpx=cx; bpy=cy; };
			};
	 };
	/* That should hopefully do it */
	/* Let's dump our solution in the file.. */
	ofstream fo("output.txt");
	fo<<bp<<endl;
	fo<<bpx<<" "<<bpy<<endl;
	for(i=bpx;i<=m+bpx;i++) {
		em *a=lx[i];
		do {
			if(a!=NULL&&y[a->p]<=bpy+n&&y[a->p]>=bpy) fo<<(int)x[a->p]<<" "<<(int)y[a->p]<<endl;
			if(a!=NULL) a=a->next;
		} while(a!=NULL&&y[a->p]<=bpy+n&&y[a->p]>=bpy);
	};
	fo.close();
	/* We _must_ remember to close the file because Borland sucks big time */
	/* This is it */
	};


